"
stx:goodies/libcairo - Cairo graphics bindings for Smalltalk/X

Copyright (C) 2008-2019 Jan Vrany

This code is licensed under Creative Commons Attribution-NonCommercial License.
For full text of the license, see file LICENSE.txt
"
"{ Package: 'stx:goodies/libcairo' }"

"{ NameSpace: Cairo }"

SharedPool subclass:#Status
	instanceVariableNames:''
	classVariableNames:'CAIRO_STATUS_SUCCESS CAIRO_STATUS_NO_MEMORY
		CAIRO_STATUS_INVALID_RESTORE CAIRO_STATUS_INVALID_POP_GROUP
		CAIRO_STATUS_NO_CURRENT_POINT CAIRO_STATUS_INVALID_MATRIX
		CAIRO_STATUS_INVALID_STATUS CAIRO_STATUS_NULL_POINTER
		CAIRO_STATUS_INVALID_STRING CAIRO_STATUS_INVALID_PATH_DATA
		CAIRO_STATUS_READ_ERROR CAIRO_STATUS_WRITE_ERROR
		CAIRO_STATUS_SURFACE_FINISHED CAIRO_STATUS_SURFACE_TYPE_MISMATCH
		CAIRO_STATUS_PATTERN_TYPE_MISMATCH CAIRO_STATUS_INVALID_CONTENT
		CAIRO_STATUS_INVALID_FORMAT CAIRO_STATUS_INVALID_VISUAL
		CAIRO_STATUS_FILE_NOT_FOUND CAIRO_STATUS_INVALID_DASH
		CAIRO_STATUS_INVALID_DSC_COMMENT CAIRO_STATUS_INVALID_INDEX
		CAIRO_STATUS_CLIP_NOT_REPRESENTABLE CAIRO_STATUS_TEMP_FILE_ERROR
		CAIRO_STATUS_INVALID_STRIDE CAIRO_STATUS_FONT_TYPE_MISMATCH
		CAIRO_STATUS_USER_FONT_IMMUTABLE CAIRO_STATUS_USER_FONT_ERROR
		CAIRO_STATUS_NEGATIVE_COUNT CAIRO_STATUS_INVALID_CLUSTERS
		CAIRO_STATUS_INVALID_SLANT CAIRO_STATUS_INVALID_WEIGHT
		CAIRO_STATUS_INVALID_SIZE CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED
		CAIRO_STATUS_DEVICE_TYPE_MISMATCH CAIRO_STATUS_DEVICE_ERROR
		CAIRO_STATUS_INVALID_MESH_CONSTRUCTION
		CAIRO_STATUS_DEVICE_FINISHED CAIRO_STATUS_JBIG2_GLOBAL_MISSING
		CAIRO_STATUS_LAST_STATUS'
	poolDictionaries:''
	category:'Cairo-Constants'
!

!Status class methodsFor:'documentation'!

copyright
"
stx:goodies/libcairo - Cairo graphics bindings for Smalltalk/X

Copyright (C) 2008-2019 Jan Vrany

This code is licensed under Creative Commons Attribution-NonCommercial License.
For full text of the license, see file LICENSE.txt
"
! !

!Status class methodsFor:'initialization'!

initialize

    CAIRO_STATUS_SUCCESS := 0.
    CAIRO_STATUS_NO_MEMORY := 1.
    CAIRO_STATUS_INVALID_RESTORE := 2.
    CAIRO_STATUS_INVALID_POP_GROUP := 3.
    CAIRO_STATUS_NO_CURRENT_POINT := 4.
    CAIRO_STATUS_INVALID_MATRIX := 5.
    CAIRO_STATUS_INVALID_STATUS := 6.
    CAIRO_STATUS_NULL_POINTER := 7.
    CAIRO_STATUS_INVALID_STRING := 8.
    CAIRO_STATUS_INVALID_PATH_DATA := 9.
    CAIRO_STATUS_READ_ERROR := 10.
    CAIRO_STATUS_WRITE_ERROR := 11.
    CAIRO_STATUS_SURFACE_FINISHED := 12.
    CAIRO_STATUS_SURFACE_TYPE_MISMATCH := 13.
    CAIRO_STATUS_PATTERN_TYPE_MISMATCH := 14.
    CAIRO_STATUS_INVALID_CONTENT := 15.
    CAIRO_STATUS_INVALID_FORMAT := 16.
    CAIRO_STATUS_INVALID_VISUAL := 17.
    CAIRO_STATUS_FILE_NOT_FOUND := 18.
    CAIRO_STATUS_INVALID_DASH := 19.
    CAIRO_STATUS_INVALID_DSC_COMMENT := 20.
    CAIRO_STATUS_INVALID_INDEX := 21.
    CAIRO_STATUS_CLIP_NOT_REPRESENTABLE := 22.
    CAIRO_STATUS_TEMP_FILE_ERROR := 23.
    CAIRO_STATUS_INVALID_STRIDE := 24.
    CAIRO_STATUS_FONT_TYPE_MISMATCH := 25.
    CAIRO_STATUS_USER_FONT_IMMUTABLE := 26.
    CAIRO_STATUS_USER_FONT_ERROR := 27.
    CAIRO_STATUS_NEGATIVE_COUNT := 28.
    CAIRO_STATUS_INVALID_CLUSTERS := 29.
    CAIRO_STATUS_INVALID_SLANT := 30.
    CAIRO_STATUS_INVALID_WEIGHT := 31.
    CAIRO_STATUS_INVALID_SIZE := 32.
    CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED := 33.
    CAIRO_STATUS_DEVICE_TYPE_MISMATCH := 34.
    CAIRO_STATUS_DEVICE_ERROR := 35.
    CAIRO_STATUS_INVALID_MESH_CONSTRUCTION := 36.
    CAIRO_STATUS_DEVICE_FINISHED := 37.
    CAIRO_STATUS_JBIG2_GLOBAL_MISSING := 38.
    CAIRO_STATUS_LAST_STATUS := 39.
! !

!Status class methodsFor:'constants'!

CAIRO_STATUS_CLIP_NOT_REPRESENTABLE

    ^CAIRO_STATUS_CLIP_NOT_REPRESENTABLE
!

CAIRO_STATUS_DEVICE_ERROR

    ^CAIRO_STATUS_DEVICE_ERROR
!

CAIRO_STATUS_DEVICE_FINISHED

    ^CAIRO_STATUS_DEVICE_FINISHED
!

CAIRO_STATUS_DEVICE_TYPE_MISMATCH

    ^CAIRO_STATUS_DEVICE_TYPE_MISMATCH
!

CAIRO_STATUS_FILE_NOT_FOUND

    ^CAIRO_STATUS_FILE_NOT_FOUND
!

CAIRO_STATUS_FONT_TYPE_MISMATCH

    ^CAIRO_STATUS_FONT_TYPE_MISMATCH
!

CAIRO_STATUS_INVALID_CLUSTERS

    ^CAIRO_STATUS_INVALID_CLUSTERS
!

CAIRO_STATUS_INVALID_CONTENT

    ^CAIRO_STATUS_INVALID_CONTENT
!

CAIRO_STATUS_INVALID_DASH

    ^CAIRO_STATUS_INVALID_DASH
!

CAIRO_STATUS_INVALID_DSC_COMMENT

    ^CAIRO_STATUS_INVALID_DSC_COMMENT
!

CAIRO_STATUS_INVALID_FORMAT

    ^CAIRO_STATUS_INVALID_FORMAT
!

CAIRO_STATUS_INVALID_INDEX

    ^CAIRO_STATUS_INVALID_INDEX
!

CAIRO_STATUS_INVALID_MATRIX

    ^CAIRO_STATUS_INVALID_MATRIX
!

CAIRO_STATUS_INVALID_MESH_CONSTRUCTION

    ^CAIRO_STATUS_INVALID_MESH_CONSTRUCTION
!

CAIRO_STATUS_INVALID_PATH_DATA

    ^CAIRO_STATUS_INVALID_PATH_DATA
!

CAIRO_STATUS_INVALID_POP_GROUP

    ^CAIRO_STATUS_INVALID_POP_GROUP
!

CAIRO_STATUS_INVALID_RESTORE

    ^CAIRO_STATUS_INVALID_RESTORE
!

CAIRO_STATUS_INVALID_SIZE

    ^CAIRO_STATUS_INVALID_SIZE
!

CAIRO_STATUS_INVALID_SLANT

    ^CAIRO_STATUS_INVALID_SLANT
!

CAIRO_STATUS_INVALID_STATUS

    ^CAIRO_STATUS_INVALID_STATUS
!

CAIRO_STATUS_INVALID_STRIDE

    ^CAIRO_STATUS_INVALID_STRIDE
!

CAIRO_STATUS_INVALID_STRING

    ^CAIRO_STATUS_INVALID_STRING
!

CAIRO_STATUS_INVALID_VISUAL

    ^CAIRO_STATUS_INVALID_VISUAL
!

CAIRO_STATUS_INVALID_WEIGHT

    ^CAIRO_STATUS_INVALID_WEIGHT
!

CAIRO_STATUS_JBIG2_GLOBAL_MISSING

    ^CAIRO_STATUS_JBIG2_GLOBAL_MISSING
!

CAIRO_STATUS_LAST_STATUS

    ^CAIRO_STATUS_LAST_STATUS
!

CAIRO_STATUS_NEGATIVE_COUNT

    ^CAIRO_STATUS_NEGATIVE_COUNT
!

CAIRO_STATUS_NO_CURRENT_POINT

    ^CAIRO_STATUS_NO_CURRENT_POINT
!

CAIRO_STATUS_NO_MEMORY

    ^CAIRO_STATUS_NO_MEMORY
!

CAIRO_STATUS_NULL_POINTER

    ^CAIRO_STATUS_NULL_POINTER
!

CAIRO_STATUS_PATTERN_TYPE_MISMATCH

    ^CAIRO_STATUS_PATTERN_TYPE_MISMATCH
!

CAIRO_STATUS_READ_ERROR

    ^CAIRO_STATUS_READ_ERROR
!

CAIRO_STATUS_SUCCESS

    ^CAIRO_STATUS_SUCCESS
!

CAIRO_STATUS_SURFACE_FINISHED

    ^CAIRO_STATUS_SURFACE_FINISHED
!

CAIRO_STATUS_SURFACE_TYPE_MISMATCH

    ^CAIRO_STATUS_SURFACE_TYPE_MISMATCH
!

CAIRO_STATUS_TEMP_FILE_ERROR

    ^CAIRO_STATUS_TEMP_FILE_ERROR
!

CAIRO_STATUS_USER_FONT_ERROR

    ^CAIRO_STATUS_USER_FONT_ERROR
!

CAIRO_STATUS_USER_FONT_IMMUTABLE

    ^CAIRO_STATUS_USER_FONT_IMMUTABLE
!

CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED

    ^CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED
!

CAIRO_STATUS_WRITE_ERROR

    ^CAIRO_STATUS_WRITE_ERROR
! !


Status initialize!
